{
Fetches all Fields, MySQL-table has, Uses mysql

1. Init a Handle to Mysql (MysqlInit)
2. Connect to Mysql (MysqlRealConnect)
3. Create a database (MysqlCreateDb)
4. Select this database as the one to use (MysqlSelectDb)
5. Create a table (MysqlQuery)
6. List all fields from this table (down from MysqlListFields)
7. Clean up (Drop the Database and so on)
}

program fetchfield;

uses mysql;

var 
	MHandle:PMysql;
	MRes : PMysqlRes;
	NumFields:Cardinal;
	i : Integer;
	field : PMysqlField;
	
begin
	MHandle:=MysqlInit(MHandle);
	if MysqlRealConnect(MHandle, 'localhost', '', '', '', 0, nil, 0) =nil then
		writeln (' Error: MysqlRealConnect returned nil ')
	else
	begin
		
		Write('Create Database ''test_mysqlunit''..');
		If Not MysqlCreateDb(MHandle, 'test_mysqlunit') Then
		Begin
		  MysqlClose(MHandle);
		  Writeln('failed!!! (Maybe exists or you don''t have the permission)');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Select Db to ''test_mysqlunit''..');
		If Not MysqlSelectDb(MHandle, 'test_mysqlunit') Then
		Begin
		  MysqlClose(MHandle);
		  Writeln('failed!!!');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Create Table ''mysqltest''..');
		If Not MysqlQuery(MHandle, 
		  'CREATE TABLE mysqltest(nr INT, firstname VARCHAR(100), lastname VARCHAR(100))') Then
		Begin
			Writeln('failed!!!');
			If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
				Writeln('Please Clean up manually');			  
			MysqlClose(MHandle);
		  Halt(1);
		End;
		Writeln('done.');

		MRes := MysqlListFields(MHandle, 'mysqltest', nil);
		if MRes = nil then
		  Writeln ('Error: table `mysqltest'' not found.')
		else
		  begin
		    NumFields := MysqlNumFields(MRes);
		    for i:=0 to NumFields-1 do
		    begin
		    	field:=MysqlFetchField(MRes);
		    	writeln(i, ') ', CString2String(field^.name))
		    end;
		    MysqlFreeResult(MRes)
		  end;

		Write('Clean up..');		
		{ Clean up }		
		If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
			Writeln('Can''t Drop Database! Please clean up manually')
		Else
			Writeln('done.');
		MysqlClose(MHandle)
	end	
end.
