{
Example for MysqlRowSeek / MysqlRowTell, uses mysql
}

program RowSeekTell;

uses mysql;

var 
	MHandle:PMysql;
	MRes : PMYsqlRes;
	row, Dummy : MysqlRow;
	NumFields : LongInt;
	NumRows : Cardinal;
	i, j : Integer;
	offst : MYSQL_ROW_OFFSET;
	
		
begin
	MHandle:=MysqlInit(MHandle);
	{ You may need to change the username "proger" to some other name...}
	if MysqlRealConnect(MHandle, 'localhost', 'proger', '', 'test', 0, nil, 0) =nil then
		writeln (' Error: MysqlRealConnect returned nil ')
	else
	begin

		Write('Create Database ''test_mysqlunit''..');
		If Not MysqlCreateDb(MHandle, 'test_mysqlunit') Then
		Begin
		  MysqlClose(MHandle);
		  Writeln('failed!!! (Maybe extists or you don''t have the permission)');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Select Db to ''test_mysqlunit''..');
		If Not MysqlSelectDb(MHandle, 'test_mysqlunit') Then
		Begin
		  MysqlClose(MHandle);
		  Writeln('failed!!!');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Create Table ''mysqltest''..');
		If Not MysqlQuery(MHandle, 
		  'CREATE TABLE mysqltest(nr INT, firstname VARCHAR(100), lastname VARCHAR(100))') Then
		Begin
			Writeln('failed!!!');
			If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
				Writeln('Please Clean up mynually');			  
			MysqlClose(MHandle);
		  Halt(1);
		End;
		Writeln('done.');

		Write('Populate the table..');
		If Not (
		   MysqlQuery(MHandle, 
		     'INSERT INTO mysqltest values(1, ''Anne'', ''Clark'')') And
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(2, ''Robert'', ''Smith'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(3, ''Paul'', ''Newman'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(4, ''Jane'', ''Fonda'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(5, ''Karl'', ''Marx'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(6, ''Bob'', ''Marley'')') ) Then
		Begin
			Writeln('failed!!!');
			If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
				Writeln('Please Clean up mynually');			  
			MysqlClose(MHandle);
		  Halt(1);
		End;
		Writeln('done.');

		if not MysqlQuery(MHandle, 'SELECT * FROM mysqltest') then
		  Writeln ('MysqlQuery returned False')
		else
		begin
			MRes := MysqlStoreResult(MHandle);
			if MRes = nil then
			  Writeln ('MysqlStoreResult returned nil')
			else
			begin
				NumFields := MysqlNumFields(MRes);
				NumRows := MysqlNumRows(MRes);
				offst := nil;
				if NumRows = 0 then
				  Writeln ('no entries')
				else
					for i := 0 to NumRows-1 do
					begin
						if i=2 then offst := MysqlRowTell(MRes);
						row := MysqlFetchRow(MRes);
						for j := 0 to NumFields-1 do write (CString2String(row^[j]), ' ');
						writeln
					end;			
				if offst = nil then
					Writeln ('not doing MysqlRowSeek -- please insert more rows...')
				else
				begin
					Dummy := MysqlRowSeek(MRes, offst);
					row := MysqlFetchRow(MRes);
					write ('after MysqlRowSeek: ');
					for j := 0 to NumFields-1 do write (CString2String(row^[j]), ' ');
					writeln
				end;
				{Free the Mem and Close MySQL }
				MysqlFreeResult(MRes);
			end
		end;

		Write('Clean up..');		
		If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
			Writeln('Can''t Drop Database! Please clean up manually')
		Else
			Writeln('done.');
		MysqlClose(MHandle)
	end	
end.
