{
Executes a Query, uses mysql
}

program simplequery;

uses mysql;

var 
	MHandle:PMysql;
	MRes : PMysqlRes;
	row : MysqlRow;
	NumFields : LongInt;
	NumRows : Cardinal;
	i, j : Integer;
	
begin
	MHandle:=MysqlInit(MHandle);
	if MysqlRealConnect(MHandle, 'localhost', '', '', '', 0, nil, 0) =nil then
		writeln (' Error: MysqlRealConnect returned nil ')
	else
	begin

		Write('Create Database ''test_mysqlunit''..');
		{ Try to create a database }
		If Not MysqlCreateDb(MHandle, 'test_mysqlunit') Then
		Begin
			{ Close the connection to the database }
		  MysqlClose(MHandle);
		  Writeln('failed!!! (Maybe extists or you don''t have the permission)');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Select Db to ''test_mysqlunit''..');
		{ Select this newly created database (similar to "USE") }
		If Not MysqlSelectDb(MHandle, 'test_mysqlunit') Then
		Begin
		  MysqlClose(MHandle);
		  Writeln('failed!!!');
		  Halt(1);
		End;	
		Writeln('done.');
		
		Write('Create Table ''mysqltest''..');
		{ Create a table mysqltest in test_mysqlunit }
		If Not MysqlQuery(MHandle, 
		  'CREATE TABLE mysqltest(nr INT, firstname VARCHAR(100), lastname VARCHAR(100))') Then
		Begin
			Writeln('failed!!!');
			If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
				Writeln('Please Clean up mynually');			  
			MysqlClose(MHandle);
		  Halt(1);
		End;
		Writeln('done.');

		{ Insert some Data in our table }
		Write('Populate the table..');
		If Not (
		   MysqlQuery(MHandle, 
		     'INSERT INTO mysqltest values(1, ''Anne'', ''Clark'')') And
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(2, ''Robert'', ''Smith'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(3, ''Paul'', ''Newman'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(4, ''Jane'', ''Fonda'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(5, ''Karl'', ''Marx'')') AND
			 MysqlQuery(MHandle, 
			   'INSERT INTO mysqltest values(6, ''Bob'', ''Marley'')') ) Then
		Begin
			Writeln('failed!!!');
			{ Try to drop the database (cleans up tables automatically) }
			If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
				Writeln('Please Clean up manually');			  
			MysqlClose(MHandle);
		  Halt(1);
		End;
		Writeln('done.');
		
		{ Select all rows from our table }
		if MysqlQuery(MHandle, 'SELECT * FROM mysqltest') then
		begin
			{ store the results }
			MRes := MysqlStoreResult(MHandle);
			if MRes = nil then
			  Writeln ('MysqlStoreResult returned nil')
			else
			begin
				{ retrive the number of Fields for our query 
				  (should be 3 for "nr", "firstname", "lastname") 
				}
				NumFields := MysqlNumFields(MRes);
				{ ... and the number of rows (must be 6 for our example) }
				NumRows := MysqlNumRows(MRes);
				{ print them out }
				writeln ('Number of Rows= ',NumRows,' Number of Fields= ',NumFields);
				if NumRows = 0 then
				  Writeln ('no entries')
				else
				begin
					{ for all rows... }
			  	for i := 0 to NumRows-1 do
			    begin
			    	{ Fetch a row }
				    row := MysqlFetchRow(MRes);
				    { print our internal number for it }
				    write (i, ') ');
				    { and print each field of our row }
				    for j := 0 to NumFields-1 do write (CSTRING2String(row^[j]), ' ');
				    writeln
			    end;
					{Free the Mem and Close MySQL }
					MysqlFreeResult(MRes)
				end				
			end
		end
		else
		  Writeln ('MysqlQuery returned False.');

		Write('Clean up..');		
		{ Drop the Database }
		If Not MysqlDropDb(MHandle, 'test_mysqlunit') Then
			Writeln('Can''t Drop Database! Please clean up manually')
		Else
			Writeln('done.');
		{ And clean the connection }
		MysqlClose(MHandle)
	end	
end.